%define name libsfio
%define version 1999
%define release 1C1
%define file0 sfio_1999.src.unix.cpio
%define extradoc sfio_1999.src.unix.README

Summary: sfio: Enhanced library for managing I/O streams
Name: %{name}
Version: %{version}
Release: %{release}
Group: System Environment/Libraries
Source0: %{file0}
Source1: %{extradoc}
Patch0: sfio_1999-redhat.patch
Patch1:	sfio_1999-infiniteloop.patch
Url: http://www.research.att.com/sw/tools/sfio/
Copyright: BSD-style
Buildroot: /tmp/%{name}-%{version}-root
Prefix: /usr
Epoch: 5

%description
Sfio is a portable library for managing I/O streams. It provides similar
functionality to the ANSI C Standard I/O functions known collectively as
Stdio. However, it has a distinct interface and is generally faster and
more robust than most Stdio implementations. Sfio also introduces a number
of new features and concepts beyond Stdio stream I/O processing.

%package devel
Summary: Header files and libraries for developing apps which will use libsfio.
Group: Development/Libraries
Requires: libsfio

%description devel
Sfio is a portable library for managing I/O streams. It provides similar
functionality to the ANSI C Standard I/O functions known collectively as
Stdio. However, it has a distinct interface and is generally faster and
more robust than most Stdio implementations. Sfio also introduces a number
of new features and concepts beyond Stdio stream I/O processing:
 * Automatic locking to avoid concurrent stream accesses,
 * I/O disciplines to pre/post-process read/write data from/to streams,
 * Stream stacking for recursive processing of nested streams,
 * Stream pooling for automatic stream synchronization when I/O operations
   are performed on different streams,
 * Buffer reservation for safe access to the internal buffers of streams,
 * Robust handling of variable-sized records, and
 * Extensible printf/scanf-like formatting I/O operations.

Install the libsfio-devel package if you want to develop applications that
will use the libsfio library.

%prep
# doh, cpio file needs manual unpacking
cd ${RPM_BUILD_DIR}
rm -rf %{name}
mkdir %{name}
cd %{name}
cpio -i --file=${RPM_SOURCE_DIR}/%{file0} --make-directories
if [ $? -ne 0 ]; then
  exit $?
fi
cd ${RPM_BUILD_DIR}/%{name}
chown -R root.root .
chmod -R a+rX,g-w,o-w .

%patch0 -p0 -b .redhat
%patch1 -p0

%build
cd ${RPM_BUILD_DIR}/%{name}
cp ${RPM_SOURCE_DIR}/%{extradoc} ABOUT
cd src/lib/sfio;
make CC=gcc RPM_OPT_FLAGS="-pipe -D_REENTRANT $RPM_OPT_FLAGS" libsfio.a install
cd ${RPM_BUILD_DIR}/%{name}/src/lib/sfio
make clean
cd ${RPM_BUILD_DIR}/%{name}/src/lib/sfio
make CC=gcc RPM_OPT_FLAGS="-pipe -fPIC -D_REENTRANT $RPM_OPT_FLAGS"  RPM_SONAME=libsfio.so libsfio.so install

%install
mkdir -p $RPM_BUILD_ROOT/usr
mkdir -p $RPM_BUILD_ROOT/lib
mkdir -p $RPM_BUILD_ROOT/etc

cd ${RPM_BUILD_DIR}/%{name}

install -D -m644 lib/libsfio.a ${RPM_BUILD_ROOT}/usr/lib/libsfio.a
install -D -m755 lib/libsfio.so ${RPM_BUILD_ROOT}/usr/lib/libsfio.so.1999
#ln -s libsfio.so.1999 ${RPM_BUILD_ROOT}/usr/lib/libsfio.so
install -d ${RPM_BUILD_ROOT}/usr/include/sfio/
install -D -m644 include/* ${RPM_BUILD_ROOT}/usr/include/sfio/
install -D -m644 man/man3/sfio.3 ${RPM_BUILD_ROOT}/usr/man/man3/

/sbin/ldconfig -r $RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc %{name}/NOTICE/sfio.notice
%doc %{name}/README
%doc %{name}/ABOUT
/usr/lib/*.so*
/usr/man/*

%files devel
%defattr(-,root,root)
/usr/include/*
/usr/lib/*.a

%changelog
* Wed Mar 21 2001 Patrick Baltz <patrick.baltz@sun.com>
- apply patch to avoid infinite loops in sendmail

* Tue Jun 6 2000 Jason Spangler <jasons@usemail.com>
- Initial creation of RPM based on Debian package
